// Event.h: interface for the Event class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_EVENT_H_INCLUDED_)
#define _EVENT_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef class Event* PEvent;

#include "Packet.h"
#include "VC.h"

enum {
  EVT_NOTHING = 1,
  EVT_PACKET,
  EVT_VC_START,
  EVT_NON_CONF,
  EVT_VC_STOP
};

typedef class Event  
{
public:
  int what;
  PPacket pPacket;
  PVC pVc;
public:
	Event();
	virtual ~Event();
  friend ostream& operator<< ( ostream& os, Event& evt );
}* PEvent;

ostream& operator<< ( ostream& os, Event& evt );

typedef vector<PEvent> VectorPEvent;
typedef VectorPEvent::iterator VectorPEventIt;

#endif // !defined(_EVENT_H_INCLUDED_)
