// Hybrid.cpp : Defines the entry point for the console application.
//

#include "StdAfx.h"
#include "Sim.h"

//For Visual C++
#ifdef  _MSC_VER
#include <crtdbg.h>  //detect memory check
//Check memory leak when in Visual C++
void EnableDebugNew()
{
  // Get current flag
  int tmpFlag = _CrtSetDbgFlag( _CRTDBG_REPORT_FLAG );

  // Turn on leak-checking bit
  tmpFlag |= _CRTDBG_LEAK_CHECK_DF;

  // Turn off CRT block checking bit
  tmpFlag &= ~_CRTDBG_CHECK_CRT_DF;

  // Set flag to the new value
  _CrtSetDbgFlag( tmpFlag );
}
#endif

int main(int argc, char* argv[])
{

#ifdef _MSC_VER
  //EnableDebugNew();
#endif

  char *sCfgFileName, *sOutputFileName, *sLogFileName;

  if ((argc == 1)||(argc>4))
  {
    Error("Usage: hybrid <config_file> [output_file] [log_file]");
  }

  sCfgFileName = argv[1];
  sOutputFileName = sLogFileName = NULL;
  if (argc>=3)
    sOutputFileName = argv[2];

  ofLog1.open("bwshare.txt");
  if (!ofLog1)
    Error("Open %s failed!",sLogFileName);

  /*
  if (argc==4)
    sLogFileName = argv[3];
  else
    sLogFileName = "vc.txt";

  ofLog2.open("fifoOut.txt");
  if (!ofLog2)
    Error("Open %s failed!",sLogFileName);
  */

  {
    Sim sim(sCfgFileName, sOutputFileName);  // config file name
    //Sim sim("d:\\WWG\\855\\Hybrid\\flow.cfg", "d:\\WWG\\855\\Hybrid\\output.txt");
  }

  int t = clock()/CLOCKS_PER_SEC;
  cout << "Run time: " << t/60 << " min " << t%60 << " sec\n";
  cout << '\a'; // beep
  return 0;
}

/*
  PEvent pevt;
  InputPort input;

  pevt = new Event; pevt->pPacket = new Packet(8,100);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(6,69);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(2,10);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(3,70);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(7,96);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(4,15);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(5,30);
  input.AddEvent(pevt);
  cout << input;

  pevt = new Event; pevt->pPacket = new Packet(1,4);
  input.AddEvent(pevt);
  cout << input;

  //while (!input.m_vecPEvent.empty())
  //{
  //  pevt = input.GetNextEvent();
  //  cout << *pevt << "\n";
  //  cout << input;
  //}
*/

