// InputPort.h: interface for the InputPort class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_INPUTPORT_H_INCLUDED_)
#define _INPUTPORT_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "global.h"	// Added by ClassView
#include "Packet.h"
#include "Event.h"
#include "VC.h"
#include "VCHash.h"
#include "Event.h"

typedef vector<int> VecInt;

// class InputPort generates Events for all virtual channels
typedef class InputPort  
{
public:
  VCHash m_vcHash;      // hash table for vc
  VectorPEvent m_vecPEvent; // heap of events
  VecInt m_vecIntTotal;
  INT64 m_prevTime;
public:
	void InitVc(ifstream &cfgFile);
	void AddEvent(PEvent pEvent);
	InputPort();
	virtual ~InputPort();
  friend ostream& operator<<( ostream& os, InputPort& port );

  // generate the next Event
  PEvent GetNextEvent();

protected:
	static BOOL LaterEvent(PEvent &x, PEvent &y);
}* PInputPort;

ostream& operator<<( ostream& os, InputPort& port );

#endif // !defined(_INPUTPORT_H_INCLUDED_)
