// Sim.h: interface for the Sim class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(_SIM_H_INCLUDED_)
#define _SIM_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Packet.h"
#include "Event.h"
#include "VC.h"
#include "Switch.h"
#include "InputPort.h"

typedef class Sim  
{
public:
  ofstream m_ofOutputFile;
  InputPort m_inputPort;
  // we can get data in all switches after one run
  VectorPSwitch m_vecPSwitch;

  INT64 m_maxTime;    // max time of the simulation
  INT64 m_curTime;    // the time that the last packet is inputed
  INT64 m_outputTime; // the time that output the last packet

  DWORD m_outputInterval; // the time needed to output a packet in cells/ns

public:
	Sim(char sCfgFileName[], char sOutputFileName[]);
	virtual ~Sim();
	void Run();
  friend ostream& operator<<( ostream& os, Sim &s );
protected:
	void Check();
	void ReadConfig(char sFileName[]);
}* PSim;

ostream& operator<<( ostream& os, Sim &s );

#endif // !defined(_SIM_H_INCLUDED_)
