// VCHash.cpp: implementation of the VCHash class.
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "VCHash.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

VCHash::VCHash(int hashSize)
{
  int i;
  ListVC listVc;

  for (i=0; i<hashSize; i++)
  {
    m_vecListVcHash.push_back(listVc);
  }
}

VCHash::~VCHash()
{

}

ListVCIt VCHash::GetVcFromHash(int vcId)
{
  ListVC *pListVc;
  ListVCIt pVc;

  pListVc = &(m_vecListVcHash[GetVcHashValue(vcId)]);
  for ( pVc=pListVc->begin(); pVc!=pListVc->end(); pVc++ )
  {
    if ( pVc->m_id == vcId )
      break;
  }
  assert(pVc != pListVc->end());
  return pVc;
}

DWORD VCHash::GetVcHashValue(int vcId)
{
  return vcId*vcId % m_vecListVcHash.size();
}

PVC VCHash::AddVc(PVC pVc)
{
  ListVC *pListVc;

  pListVc = &(m_vecListVcHash[GetVcHashValue(pVc->m_id)]);
  pListVc->push_back(*pVc);
  return &(pListVc->back());
}

void VCHash::EraseVc(ListVCIt vcIt)
{
  ListVC &listVc=m_vecListVcHash[GetVcHashValue(vcIt->m_id)];
  listVc.erase(vcIt);
}
