#if !defined(_GLOBAL_H_INCLUDED_)
#define _GLOBAL_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once

// The debugger can't handle symbols more than 255 characters long.
// STL often creates symbols longer than that.
// When symbols are longer than 255 characters, the warning is issued.
#pragma warning(disable:4786)

#endif // _MSC_VER > 1000

//#include <ios>
#include <iostream>
#include <fstream>
#include <queue>
#include <list>
#include <algorithm>
#include <cassert>
#include <string>
#include <cstdarg>
#include <string.h>
#include <math.h>
#include <strstream>
#include <time.h>
#include <limits.h>
#include <float.h>

//#ifdef  _MSC_VER  //For Visual C++
//#ifdef _DEBUG
//#include <afx.h>
//#define new DEBUG_NEW // need use MFC as shared DLL
//#endif
//#include <crtdbg.h>  //detect memory check
//#endif

using namespace std;

//For compatablity between UNIX and Windows
#ifdef _MSC_VER // on Visual C++

#include <afx.h>
  typedef __int64 INT64;
  #define PATH_MAX     _MAX_PATH
  #define popen(x,y)   _popen(x,y)
  #define pclose(x)    _pclose(x)

#else // on UNIX for gcc

  typedef long long int INT64;
  #define stricmp(x,y) strcasecmp(x,y)

#endif //_MSC_VER

//typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef int BOOL;

#define FALSE   0
#define TRUE    1

enum
{
  VC_NORMAL=1,
  VC_STOP
};

#define RAND_M  2147483647    // max random value
#define TimeScale INT64(1000000000)  // the smallest time granulity is 1 ns
#define HASH_SIZE 499

typedef vector<double> VectorDouble;
typedef VectorDouble::iterator VectorDoubleIt;

#if defined(_MSC_VER)
ostream& operator<<( ostream& os, INT64 i );
#endif

#define verify(exp) if((exp));else Error("Error %s in %s(%d)",#exp, __FILE__, __LINE__)

void Error(char *fmt, ...);

// read a line, ignore comment lines and empty lines
void ReadLine(ifstream &f, char line[], int len);

// return TRUE if this line only contains blank space or tabs or begin with #
BOOL IsBlank(char line[]);

inline int round(double d) { return int(d+0.5); };

extern int CELL_SIZE;        // size of cell

extern ofstream ofLog1;
extern ofstream ofLog2;

#endif // !defined(_GLOBAL_H_INCLUDED_)
