// RandGen.cpp: implementation of the Event class.
//
//////////////////////////////////////////////////////////////////////

#include "StdAfx.h"
#include "RandGen.h"

/*****************************************************************************
 * Random Generator public methods                                           *
 *****************************************************************************/

/*
 * constructor
 */
RandGen::RandGen()
{
  seed = 1;
}

/*
 * destructor
 */

RandGen::~RandGen() 
{
}

/*
 * srandom()
 *
 * This function initialize the seed. The default value is 1
 */

void RandGen::srandom (int initial_seed)
{
  if ((initial_seed < 1) || (initial_seed > RAND_M1))
  { 
    printf("Seed %d error!\n",initial_seed);
  }
  else
  {
    seed = initial_seed;
  }
}

/*
 * random()
 *
 * This function generates a random number
 */
int RandGen::random (void)
{
 int lo, hi, test;

 hi = seed / RAND_Q;
 lo = seed % RAND_Q;

 test = RAND_A * lo - RAND_R * hi;

 if (test > 0)
   seed = test;
 else
   seed = test + RAND_M;

 return(seed);
}
